Index: trunk/NEMO/OPA_SRC/ZDF/zdftke.F90
===================================================================
--- trunk/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 507)
+++ trunk/NEMO/OPA_SRC/ZDF/zdftke.F90	(revision 508)
@@ -5,67 +5,75 @@
    !!                 turbulent closure parameterization
    !!=====================================================================
+   !! History :   6.0  !  91-03  (b. blanke)  Original code
+   !!             7.0  !  91-11  (G. Madec)   bug fix
+   !!             7.1  !  92-10  (G. Madec)   new mixing length and eav
+   !!             7.2  !  93-03  (M. Guyon)   symetrical conditions
+   !!             7.3  !  94-08  (G. Madec, M. Imbard)   npdl flag
+   !!             7.5  !  96-01  (G. Madec)   s-coordinates
+   !!             8.0  !  97-07  (G. Madec)   lbc
+   !!             8.1  !  99-01  (E. Stretta) new option for the mixing length
+   !!             8.5  !  02-06  (G. Madec) add zdf_tke_init routine
+   !!             8.5  !  02-08  (G. Madec)  ri_c and Free form, F90
+   !!             9.0  !  04-10  (C. Ethe )  1D configuration
+   !!             9.0  !  02-08  (G. Madec)  autotasking optimization
+   !!             9.0  !  06-07  (S. Masson)  distributed restart using iom
+   !!----------------------------------------------------------------------
 #if defined key_zdftke   ||   defined key_esopa
    !!----------------------------------------------------------------------
-   !!   'key_zdftke'                                             TKE scheme
+   !!   'key_zdftke'                                   TKE vertical physics
+   !!----------------------------------------------------------------------
    !!----------------------------------------------------------------------
    !!   zdf_tke      : update momentum and tracer Kz from a tke scheme
    !!   zdf_tke_init : initialization, namelist read, and parameters control
+   !!   tke_rst      : read/write tke restart in ocean restart file
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and active tracers 
    USE dom_oce         ! ocean space and time domain
    USE zdf_oce         ! ocean vertical physics
-   USE in_out_manager  ! I/O manager
-   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE phycst          ! physical constants
    USE taumod          ! surface stress
+   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE prtctl          ! Print control
+   USE in_out_manager  ! I/O manager
+   USE iom
+   USE restart         ! only for lrst_oce
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC zdf_tke        ! routine called in step module
-   PUBLIC zdf_tke_init   ! routine called in zdftke_jki module
-
-   !! * Share Module variables
-   LOGICAL, PUBLIC, PARAMETER ::   lk_zdftke = .TRUE.    !: TKE vertical mixing flag
-   LOGICAL, PUBLIC ::         & !!: ** tke namelist (namtke) **
-     ln_rstke = .FALSE.          !: =T restart with tke from a run without tke with 
-     !                           !  a none zero initial value for en
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   &   !:
-      en                         !: now turbulent kinetic energy
-
-   INTEGER, PUBLIC ::         & !!! ** tke namelist (namtke) **
-      nitke = 50 ,            &  ! number of restart iterative loops
-      nmxl  =  2 ,            &  ! = 0/1/2/3 flag for the type of mixing length used
-      npdl  =  1 ,            &  ! = 0/1/2 flag on prandtl number on vert. eddy coeff.
-      nave  =  1 ,            &  ! = 0/1 flag for horizontal average on avt, avmu, avmv
-      navb  =  0                 ! = 0/1 flag for constant or profile background avt
-   REAL(wp), PUBLIC ::        & !!! ** tke namlist (namtke) **
-      ediff = 0.1_wp       ,  &  ! coeff. for vertical eddy coef.; avt=ediff*mxl*sqrt(e)
-      ediss = 0.7_wp       ,  &  ! coef. of the Kolmogoroff dissipation 
-      ebb   = 3.75_wp      ,  &  ! coef. of the surface input of tke
-      efave = 1._wp        ,  &  ! coef. for the tke vert. diff. coeff.; avtke=efave*avm
-      emin  = 0.7071e-6_wp ,  &  ! minimum value of tke (m2/s2)
-      emin0 = 1.e-4_wp     ,  &  ! surface minimum value of tke (m2/s2)
-      ri_c  = 2._wp / 9._wp      ! critic Richardson number
-   REAL(wp), PUBLIC ::        &
-      eboost                     ! multiplicative coeff of the shear product.
-
-   !! caution vectopt_memory change the solution (last digit of the solver stat)
+   PUBLIC   zdf_tke        ! routine called in step module
+   PUBLIC   zdf_tke_init   ! routine also called in zdftke_jki module
+   PUBLIC   tke_rst        ! routine also called in zdftke_jki module
+
+   LOGICAL , PUBLIC, PARAMETER              ::   lk_zdftke = .TRUE.  !: TKE vertical mixing flag
+   REAL(wp), PUBLIC                         ::   eboost              !: multiplicative coeff of the shear product.
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   en                  !: now turbulent kinetic energy
 # if defined key_vectopt_memory
-   REAL(wp), DIMENSION(jpi,jpj,jpk), PUBLIC ::   &
-      etmean,    &  ! coefficient used for horizontal smoothing
-      eumean,    &  ! at t-, u- and v-points
-      evmean        !
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   etmean              !: coefficient used for horizontal smoothing
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   eumean, evmean      !: at t-, u- and v-points
 # endif
 
+   !! * Namelist (namtke)
+   LOGICAL , PUBLIC ::   ln_rstke = .FALSE.         !: =T restart with tke from a run without tke with 
+     !                                              !  a none zero initial value for en
+   INTEGER , PUBLIC ::   nitke = 50 ,            &  !: number of restart iterative loops
+      &                  nmxl  =  2 ,            &  !: = 0/1/2/3 flag for the type of mixing length used
+      &                  npdl  =  1 ,            &  !: = 0/1/2 flag on prandtl number on vert. eddy coeff.
+      &                  nave  =  1 ,            &  !: = 0/1 flag for horizontal average on avt, avmu, avmv
+      &                  navb  =  0                 !: = 0/1 flag for constant or profile background avt
+   REAL(wp), PUBLIC ::   ediff = 0.1_wp       ,  &  !: coeff. for vertical eddy coef.; avt=ediff*mxl*sqrt(e)
+      &                  ediss = 0.7_wp       ,  &  !: coef. of the Kolmogoroff dissipation 
+      &                  ebb   = 3.75_wp      ,  &  !: coef. of the surface input of tke
+      &                  efave = 1._wp        ,  &  !: coef. for the tke vert. diff. coeff.; avtke=efave*avm
+      &                  emin  = 0.7071e-6_wp ,  &  !: minimum value of tke (m2/s2)
+      &                  emin0 = 1.e-4_wp     ,  &  !: surface minimum value of tke (m2/s2)
+      &                  ri_c  = 2._wp / 9._wp      !: critic Richardson number
+   NAMELIST/namtke/ ln_rstke, ediff, ediss, ebb, efave, emin, emin0,   &
+      &             ri_c, nitke, nmxl, npdl, nave, navb
+
 # if defined key_cfg_1d
-   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   &   
-      e_dis,    &   ! dissipation turbulent lengh scale
-      e_mix,    &   ! mixing turbulent lengh scale
-      e_pdl,    &   ! prandl number
-      e_ric         ! local Richardson number
+   !                                                                   ! 1D cfg only
+   REAL(wp), PUBLIC, DIMENSION(jpi,jpj,jpk) ::   e_dis, e_mix,      &  ! dissipation and mixing turbulent lengh scales
+      &                                          e_pdl, e_ric          ! prandl and local Richardson numbers
 #endif
 
@@ -74,10 +82,12 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !!   OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! $Header$ 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
 CONTAINS
 
-   SUBROUTINE zdf_tke ( kt )
+   SUBROUTINE zdf_tke( kt )
       !!----------------------------------------------------------------------
       !!                   ***  ROUTINE zdf_tke  ***
@@ -136,45 +146,27 @@
       !!                update avt, avmu, avmv (before vertical eddy coef.)
       !!
-      !! References :
-      !!      Gaspar et al., jgr, 95, 1990,
-      !!      Blanke and Delecluse, jpo, 1991
-      !! History :
-      !!   6.0  !  91-03  (b. blanke)  Original code
-      !!   7.0  !  91-11  (G. Madec)   bug fix
-      !!   7.1  !  92-10  (G. Madec)   new mixing length and eav
-      !!   7.2  !  93-03  (M. Guyon)   symetrical conditions
-      !!   7.3  !  94-08  (G. Madec, M. Imbard)   npdl flag
-      !!   7.5  !  96-01  (G. Madec)   s-coordinates
-      !!   8.0  !  97-07  (G. Madec)   lbc
-      !!   8.1  !  99-01  (E. Stretta) new option for the mixing length
-      !!   8.5  !  02-08  (G. Madec)  ri_c and Free form, F90
-      !!   9.0  !  04-10  (C. Ethe )  1D configuration
+      !! References : Gaspar et al., jgr, 95, 1990,
+      !!              Blanke and Delecluse, jpo, 1991
       !!----------------------------------------------------------------------
-      !! * Modules used
       USE oce     , zwd   => ua,  &  ! use ua as workspace
          &          zmxlm => ta,  &  ! use ta as workspace
          &          zmxld => sa      ! use sa as workspace
-
-      !! * arguments
-      INTEGER, INTENT( in  ) ::   kt ! ocean time step
-
-      !! * local declarations
-      INTEGER ::   ji, jj, jk        ! dummy loop arguments
-      REAL(wp) ::   &
-         zmlmin, zbbrau,          &  ! temporary scalars
-         zfact1, zfact2, zfact3,  &  !
-         zrn2, zesurf,            &  !
-         ztx2, zty2, zav,         &  !
-         zcoef, zcof, zsh2,       &  !
-         zdku, zdkv, zpdl, zri,   &  !
-         zsqen, zesh2,            &  !
-         zemxl, zemlm, zemlp
+      !
+      INTEGER, INTENT(in) ::   kt ! ocean time step
+      !
+      INTEGER  ::   ji, jj, jk                  ! dummy loop arguments
+      REAL(wp) ::   zmlmin, zbbrau,          &  ! temporary scalars
+         &          zfact1, zfact2, zfact3,  &  !
+         &          zrn2, zesurf,            &  !
+         &          ztx2, zty2, zav,         &  !
+         &          zcoef, zcof, zsh2,       &  !
+         &          zdku, zdkv, zpdl, zri,   &  !
+         &          zsqen, zesh2,            &  !
+         &          zemxl, zemlm, zemlp
       !!--------------------------------------------------------------------
 
-      ! Initialization (first time-step only)
-      ! --------------
-      IF( kt == nit000  )   CALL zdf_tke_init
-
-      ! Local constant initialization
+      IF( kt == nit000  )   CALL zdf_tke_init      ! Initialization (first time-step only)
+
+      !                                            ! Local constant initialization
       zmlmin = 1.e-8
       zbbrau =  .5 * ebb / rau0
@@ -183,9 +175,7 @@
       zfact3 = 0.5 * rdt * ediss
 
-
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
       ! I.  Mixing length
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
-
 
       ! Buoyancy length scale: l=sqrt(2*e/n**2)
@@ -204,5 +194,4 @@
          END DO
       END DO
-
 
       ! Physical limits for the mixing length
@@ -291,9 +280,7 @@
 # endif
 
-
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
       ! II  Tubulent kinetic energy time stepping
       !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
-
 
       ! 1. Vertical eddy viscosity on tke (put in zmxlm) and first estimate of avt
@@ -475,5 +462,4 @@
       CALL lbc_lnk( en , 'W', 1. )   ;   CALL lbc_lnk( avt, 'W', 1. )
 
-
       !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
       ! III.  Before vertical eddy vicosity and diffusivity coefficients
@@ -601,4 +587,8 @@
       ! ------------------------------=====
       CALL lbc_lnk( avt, 'W', 1. )
+
+      ! write en in restart file
+      ! ------------------------
+      IF( lrst_oce )   CALL tke_rst( kt, 'WRITE' )
 
       IF(ln_ctl) THEN
@@ -624,21 +614,14 @@
       !! ** Action  :   Increase by 1 the nstop flag is setting problem encounter
       !!
-      !! history :
-      !!  8.5  ! 02-06 (G. Madec) original code
       !!----------------------------------------------------------------------
-      !! * Module used
       USE dynzdf_exp
       USE trazdf_exp
-
-      !! * local declarations
-      !! caution vectopt_memory change the solution (last digit of the solver stat)
+      !
 # if defined key_vectopt_memory
-      INTEGER ::   ji, jj, jk, jit   ! dummy loop indices
+      ! caution vectopt_memory change the solution (last digit of the solver stat)
+      INTEGER ::   ji, jj, jk   ! dummy loop indices
 # else
-      INTEGER ::           jk, jit   ! dummy loop indices
+      INTEGER ::           jk   ! dummy loop indices
 # endif
-
-      NAMELIST/namtke/ ln_rstke, ediff, ediss, ebb, efave, emin, emin0,   &
-         ri_c, nitke, nmxl, npdl, nave, navb
       !!----------------------------------------------------------------------
 
@@ -681,5 +664,5 @@
       ! Check nmxl and npdl values
       IF( nmxl < 0 .OR. nmxl > 3 ) CALL ctl_stop( '          bad flag: nmxl is < 0 or > 3 ' )
-      IF ( npdl < 0 .OR. npdl > 1 ) CALL ctl_stop( '          bad flag: npdl is < 0 or > 1 ' )
+      IF( npdl < 0 .OR. npdl > 1 ) CALL ctl_stop( '          bad flag: npdl is < 0 or > 1 ' )
 
       ! Horizontal average : initialization of weighting arrays 
@@ -691,6 +674,6 @@
          IF(lwp) WRITE(numout,*) '          no horizontal average on avt, avmu, avmv'
          IF(lwp) WRITE(numout,*) '          only in very high horizontal resolution !'
-!! caution vectopt_memory change the solution (last digit of the solver stat)
 # if defined key_vectopt_memory
+         ! caution vectopt_memory change the solution (last digit of the solver stat)
          ! weighting mean arrays etmean, eumean and evmean
          !           ( 1  1 )                                          ( 1 )
@@ -720,6 +703,6 @@
       CASE ( 1 )                ! horizontal average 
          IF(lwp) WRITE(numout,*) '          horizontal average on avt, avmu, avmv'
-!! caution vectopt_memory change the solution (last digit of the solver stat)
 # if defined key_vectopt_memory
+         ! caution vectopt_memory change the solution (last digit of the solver stat)
          ! weighting mean arrays etmean, eumean and evmean
          !           ( 1  1 )              ( 1/2  1/2 )             ( 1/2  1  1/2 )
@@ -790,21 +773,48 @@
 
 
-      ! Initialization of turbulent kinetic energy ( en )
+      ! read or initialize turbulent kinetic energy ( en )
       ! -------------------------------------------------
-      IF( ln_rstart ) THEN
-         ! no en field in the restart file, en set by iterative loop
-         IF( ln_rstke ) THEN
-            en (:,:,:) = emin * tmask(:,:,:)
-            DO jit = 2, nitke+1
-               CALL zdf_tke( jit )
-            END DO
-         ENDIF
-         ! otherwise en is already read in dtrlec called by inidtr
-      ELSE
-         ! no restart: en set to emin
-         en(:,:,:) = emin * tmask(:,:,:)
-      ENDIF
-
+      CALL tke_rst( nit000, 'READ' )
+      !
    END SUBROUTINE zdf_tke_init
+
+
+   SUBROUTINE tke_rst( kt, cdrw )
+     !!---------------------------------------------------------------------
+     !!                   ***  ROUTINE ts_rst  ***
+     !!                     
+     !! ** Purpose : Read or write filtered free surface arrays in restart file
+     !!
+     !! ** Method  : 
+     !!
+     !!----------------------------------------------------------------------
+     INTEGER         , INTENT(in) ::   kt         ! ocean time-step
+     CHARACTER(len=*), INTENT(in) ::   cdrw       ! "READ"/"WRITE" flag
+     !
+     INTEGER ::   jit   ! dummy loop indices
+     !!----------------------------------------------------------------------
+     !
+     IF( TRIM(cdrw) == 'READ' ) THEN
+        IF( ln_rstart ) THEN
+           IF( iom_varid( numror, 'en' ) > 0 .AND. .NOT.(ln_rstke) ) THEN 
+              CALL iom_get( numror, jpdom_local, 'en', en )
+           ELSE
+              IF(lwp .AND. iom_varid(numror,'en') > 0 ) WRITE(numout,*) ' ===>>>> : previous run without tke scheme'
+              IF(lwp .AND. ln_rstke ) WRITE(numout,*) ' ===>>>> : We do not use en from the restart file'
+              IF(lwp) WRITE(numout,*) ' ===>>>> : en set by iterative loop'
+              IF(lwp) WRITE(numout,*) ' =======             ========='
+              en (:,:,:) = emin * tmask(:,:,:)
+              DO jit = 2, nitke+1
+                 CALL zdf_tke( jit )
+              END DO
+           ENDIF
+        ELSE
+           en(:,:,:) = emin * tmask(:,:,:)      ! no restart: en set to emin
+        ENDIF
+     ELSEIF( TRIM(cdrw) == 'WRITE' ) THEN
+        CALL iom_rstput( kt, nitrst, numrow, 'en', en )
+     ENDIF
+     !
+   END SUBROUTINE tke_rst
 
 #else
@@ -812,5 +822,5 @@
    !!   Dummy module :                                        NO TKE scheme
    !!----------------------------------------------------------------------
-   LOGICAL, PUBLIC, PARAMETER ::   lk_zdftke = .FALSE.   !: TKE flag
+   PUBLIC, LOGICAL, PARAMETER ::   lk_zdftke = .FALSE.   !: TKE flag
 CONTAINS
    SUBROUTINE zdf_tke( kt )          ! Empty routine
Index: trunk/NEMO/OPA_SRC/ZDF/zdftke_jki.F90
===================================================================
--- trunk/NEMO/OPA_SRC/ZDF/zdftke_jki.F90	(revision 507)
+++ trunk/NEMO/OPA_SRC/ZDF/zdftke_jki.F90	(revision 508)
@@ -5,4 +5,7 @@
    !!                 turbulent closure parameterization
    !!=====================================================================
+   !! History :
+   !!   9.0  !  02-08  (G. Madec)  autotasking optimization
+   !!----------------------------------------------------------------------
 #if defined key_zdftke   ||   defined key_esopa
    !!----------------------------------------------------------------------
@@ -23,4 +26,5 @@
    USE taumod          ! surface stress
    USE prtctl          ! Print control
+   USE restart         ! only for lrst_oce
 
    IMPLICIT NONE
@@ -99,6 +103,4 @@
       !!      Gaspar et al., jgr, 95, 1990,
       !!      Blanke and Delecluse, jpo, 1991
-      !! History :
-      !!   9.0  !  02-08  (G. Madec)  autotasking optimization
       !!----------------------------------------------------------------------
       !! * Modules used
@@ -518,4 +520,8 @@
       CALL lbc_lnk( avt, 'W', 1. )
 
+      ! write en in restart file
+      ! ------------------------
+      IF( lrst_oce )   CALL tke_rst( kt, 'WRITE' )
+
       IF(ln_ctl) THEN
          CALL prt_ctl(tab3d_1=en  , clinfo1=' tke  - e: ', tab3d_2=avt , clinfo2=' t: ', ovlap=1, kdim=jpk)
Index: trunk/NEMO/OPA_SRC/in_out_manager.F90
===================================================================
--- trunk/NEMO/OPA_SRC/in_out_manager.F90	(revision 507)
+++ trunk/NEMO/OPA_SRC/in_out_manager.F90	(revision 508)
@@ -1,65 +1,66 @@
 MODULE in_out_manager   
+   !!======================================================================
+   !!                       ***  MODULE  in_out_manager  ***
+   !! Ocean physics:  vertical mixing coefficient compute from the tke 
+   !!                 turbulent closure parameterization
+   !!=====================================================================
+   !! History :   8.5  !  02-06  (G. Madec)  original code
+   !!             9.0  !  06-07  (S. Masson)  iom, add ctl_stop, ctl_warn
+   !!----------------------------------------------------------------------
 
-   USE lib_print         ! formated print library
+   !!----------------------------------------------------------------------
+   !!   ctl_stop   : update momentum and tracer Kz from a tke scheme
+   !!   ctl_warn   : initialization, namelist read, and parameters control
+   !!----------------------------------------------------------------------
    USE par_kind
    USE par_oce
+   USE lib_print         ! formated print library
 
    PUBLIC
 
    !!----------------------------------------------------------------------
-   !! namelist parameters
-   !! -------------------------------------
-   ! namrun:  parameters of the run
-   CHARACTER (len=16) ::    &   !:
-      cexper = "exp0"           !: experiment name used for output filename
-   
-   LOGICAL ::   &              !!: * namelist namrun *
-      ln_rstart = .FALSE. ,  &  !: start from (F) rest or (T) a restart file
-      ln_ctl    = .FALSE.       !: run control for debugging
-   
-   INTEGER ::                & !!: * namelist namrun *
-      no     = 0        ,    &  !: job number
-      nrstdt = 0        ,    &  !: control of the time step (0, 1 or 2)
-      nit000 = 1        ,    &  !: index of the first time step
-      nitend = 10       ,    &  !: index of the last time step
-      ndate0 = 961115   ,    &  !: initial calendar date aammjj
-      nleapy = 0        ,    &  !: Leap year calendar flag (0/1 or 30)
-      ninist = 0        ,    &  !: initial state output flag (0/1)
-      nbench = 0                !: benchmark parameter (0/1)
+   !!                   namrun namelist parameters
+   !!----------------------------------------------------------------------
+   CHARACTER (len=16) ::   cexper    = "exp0"        !: experiment name used for output filename
+   LOGICAL            ::   ln_rstart = .FALSE. ,  &  !: start from (F) rest or (T) a restart file
+      &                    ln_ctl    = .FALSE.       !: run control for debugging
+   INTEGER            ::   no     = 0        ,    &  !: job number
+      &                    nrstdt = 0        ,    &  !: control of the time step (0, 1 or 2)
+      &                    nit000 = 1        ,    &  !: index of the first time step
+      &                    nitend = 10       ,    &  !: index of the last time step
+      &                    ndate0 = 961115   ,    &  !: initial calendar date aammjj
+      &                    nleapy = 0        ,    &  !: Leap year calendar flag (0/1 or 30)
+      &                    ninist = 0        ,    &  !: initial state output flag (0/1)
+      &                    nbench = 0                !: benchmark parameter (0/1)
    
    !!----------------------------------------------------------------------
-   !! output monitoring
-   !! -----------------------------------
-
-   INTEGER ::                &  !:
-      nstock =   10 ,        &  !: restart file frequency
-      nprint =    0 ,        &  !: level of print (0 no print)
-      nwrite =   10 ,        &  !: restart file frequency
-      nictls =    0 ,        &  !: Start i indice for the SUM control
-      nictle =    0 ,        &  !: End   i indice for the SUM control
-      njctls =    0 ,        &  !: Start j indice for the SUM control
-      njctle =    0 ,        &  !: End   j indice for the SUM control
-      isplt  =    1 ,        &  !: number of processors following i
-      jsplt  =    1 ,        &  !: number of processors following j
-      ijsplt =    1             !: nb of local domain = nb of processors
+   !!                    output monitoring
+   !!----------------------------------------------------------------------
+   INTEGER ::   nstock =   10 ,        &  !: restart file frequency
+      &         nprint =    0 ,        &  !: level of print (0 no print)
+      &         nwrite =   10 ,        &  !: restart file frequency
+      &         nictls =    0 ,        &  !: Start i indice for the SUM control
+      &         nictle =    0 ,        &  !: End   i indice for the SUM control
+      &         njctls =    0 ,        &  !: Start j indice for the SUM control
+      &         njctle =    0 ,        &  !: End   j indice for the SUM control
+      &         isplt  =    1 ,        &  !: number of processors following i
+      &         jsplt  =    1 ,        &  !: number of processors following j
+      &         ijsplt =    1             !: nb of local domain = nb of processors
 
    !!----------------------------------------------------------------------
-   !! logical units
-   !! ------------------------------
-   INTEGER ::                &  !:
-      numstp     =  1 ,      &  !: logical unit for time step
-      numout     =  2 ,      &  !: logical unit for output print
-      numnam     =  3 ,      &  !: logical unit for namelist
-      numnam_ice =  4 ,      &  !: logical unit for ice namelist
-      numevo_ice = 17 ,      &  !: logical unit for ice variables (temp. evolution)
-      numice_dmp = 18 ,      &  !: logical unit for ice variables (damping)
-      numsol     = 25 ,      &  !: logical unit for solver statistics
-      numwri     = 40 ,      &  !: logical unit for output write
-      numisp     = 41 ,      &  !: logical unit for island statistics
-      numgap     = 45 ,      &  !: logical unit for differences diagnostic
-      numbol     = 67 ,      &  !: logical unit for "bol" diagnostics
-      numptr     = 68 ,      &  !: logical unit for Poleward TRansports
-      numflo     = 69           !: logical unit for drifting floats
-      !                         !: * coupled units
+   !!                        logical units
+   !!----------------------------------------------------------------------
+   INTEGER ::   numstp     =  1 ,      &  !: logical unit for time step
+      &         numout     =  2 ,      &  !: logical unit for output print
+      &         numnam     =  3 ,      &  !: logical unit for namelist
+      &         numnam_ice =  4 ,      &  !: logical unit for ice namelist
+      &         numevo_ice = 17 ,      &  !: logical unit for ice variables (temp. evolution)
+      &         numsol     = 25 ,      &  !: logical unit for solver statistics
+      &         numwri     = 40 ,      &  !: logical unit for output write
+      &         numisp     = 41 ,      &  !: logical unit for island statistics
+      &         numgap     = 45 ,      &  !: logical unit for differences diagnostic
+      &         numbol     = 67 ,      &  !: logical unit for "bol" diagnostics
+      &         numptr     = 68 ,      &  !: logical unit for Poleward TRansports
+      &         numflo     = 69           !: logical unit for drifting floats
 
    !!----------------------------------------------------------------------
@@ -67,27 +68,18 @@
    !!----------------------------------------------------------------------
    
-   INTEGER ::                &  !:
-      nstop = 0 ,            &  !: e r r o r  flag (=number of reason for a
-      !                         !                   prematurely stop the run)
-      nwarn = 0                 !: w a r n i n g  flag (=number of warning
-      !                         !                       found during the run)
-
-   
-   CHARACTER(LEN=100) :: ctmp1, ctmp2, ctmp3    ! temporary character
-   CHARACTER (len=64) ::        &                                                    !:
-      cform_err="(/,' ===>>> : E R R O R',     /,'         ===========',/)"    ,   & !:
-      cform_war="(/,' ===>>> : W A R N I N G', /,'         ===============',/)"      !:
-   LOGICAL ::   &               !:
-      lwp                ,   &  !: boolean : true on the 1st processor only
-      lsp_area = .TRUE.         !: to make a control print over a specific area
+   INTEGER            ::   nstop = 0 ,           &  !: error flag (=number of reason for a premature stop run)
+      &                    nwarn = 0                !: warning flag (=number of warning found during the run)
+   CHARACTER(LEN=100) ::   ctmp1, ctmp2, ctmp3      !: temporary character
+   CHARACTER (len=64) ::   cform_err="(/,' ===>>> : E R R O R',     /,'         ===========',/)"    ,   &  !:
+      &                    cform_war="(/,' ===>>> : W A R N I N G', /,'         ===============',/)"       !:
+   LOGICAL            ::   lwp               ,   &  !: boolean : true on the 1st processor only
+      &                    lsp_area = .TRUE.        !: to make a control print over a specific area
    !!----------------------------------------------------------------------
    !!  OPA 9.0 , LOCEAN-IPSL (2005) 
    !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
-
 CONTAINS
-
 
    SUBROUTINE ctl_stop( cd1, cd2, cd3, cd4, cd5,   &
@@ -96,10 +88,10 @@
       !!                  ***  ROUTINE  stop_opa  ***
       !!
-      !! ** Purpose : ???
-      !!
+      !! ** Purpose : ??? blah blah....
       !!-----------------------------------------------------------------------
-      CHARACTER(len=*),INTENT(in),OPTIONAL ::  cd1, cd2, cd3, cd4, cd5, cd6, cd7, cd8, cd9, cd10
+      CHARACTER(len=*), INTENT(in), OPTIONAL ::  cd1, cd2, cd3, cd4, cd5,   &
+         &                                       cd6, cd7, cd8, cd9, cd10
       !!-----------------------------------------------------------------------
-      
+      !
       nstop = nstop + 1 
       IF(lwp) THEN
@@ -117,5 +109,5 @@
       ENDIF
       CALL FLUSH(numout)
-
+      !
    END SUBROUTINE ctl_stop
 
@@ -124,12 +116,12 @@
       &                 cd6, cd7, cd8, cd9, cd10 )
       !!-----------------------------------------------------------------------
-      !!                  ***  ROUTINE  stop_opa  ***
+      !!                  ***  ROUTINE  stop_warn  ***
       !!
-      !! ** Purpose : ???
-      !!
+      !! ** Purpose : ???  blah blah....
       !!-----------------------------------------------------------------------
-      CHARACTER(len=*),INTENT(in),OPTIONAL ::  cd1, cd2, cd3, cd4, cd5, cd6, cd7, cd8, cd9, cd10
+      CHARACTER(len=*), INTENT(in), OPTIONAL ::  cd1, cd2, cd3, cd4, cd5,   &
+         &                                       cd6, cd7, cd8, cd9, cd10
       !!-----------------------------------------------------------------------
-      
+      ! 
       nwarn = nwarn + 1 
       IF(lwp) THEN
@@ -147,6 +139,7 @@
       ENDIF
       CALL FLUSH(numout)
-
+      !
    END SUBROUTINE ctl_warn
 
+   !!=====================================================================
 END MODULE in_out_manager
